//
// RecipientsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class RecipientsAPI {
    /**
     * enum for parameter sortField
     */
    public enum SortField_getRecipients: String { 
        case jobid = "jobId"
        case faxnumber = "faxNumber"
        case faxnumbernorm = "faxNumberNorm"
        case internationaldialingcode = "internationalDialingCode"
        case recipientreference = "recipientReference"
        case farezone = "fareZone"
        case sendertime = "senderTime"
    }

    /**
     * enum for parameter sortOrder
     */
    public enum SortOrder_getRecipients: String { 
        case asc = "asc"
        case desc = "desc"
    }

    /**
     /recipients

     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterJobId: (query) Query parameter to fetch after recipient related to specific fax job (optional)
     - parameter filterSameAccount: (query) Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     - parameter filterFaxNumber: (query) Query parameter to fetch recipients after his fax number (optional)
     - parameter filterFaxNumberNorm: (query) Query parameter to fetch recipients after his normed fax number (optional)
     - parameter filterRecipientReference: (query) Query parameter to fetch recipients after his recipient reference (optional)
     - parameter filterInternationalDialingCode: (query) Query parameter to fetch recipients after his international dialing code (optional)
     - parameter filterResultCode: (query) Query parameter to fetch recipients after his result code (optional)
     - parameter filterResultText: (query) Query parameter to fetch recipients after his result text (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getRecipients(objectLimit: Int? = nil, objectOffset: Int? = nil, filterJobId: String? = nil, filterSameAccount: Bool? = nil, filterFaxNumber: String? = nil, filterFaxNumberNorm: String? = nil, filterRecipientReference: String? = nil, filterInternationalDialingCode: String? = nil, filterResultCode: String? = nil, filterResultText: String? = nil, sortField: SortField_getRecipients? = nil, sortOrder: SortOrder_getRecipients? = nil, completion: @escaping ((_ data: Recipients?,_ error: Error?) -> Void)) {
        getRecipientsWithRequestBuilder(objectLimit: objectLimit, objectOffset: objectOffset, filterJobId: filterJobId, filterSameAccount: filterSameAccount, filterFaxNumber: filterFaxNumber, filterFaxNumberNorm: filterFaxNumberNorm, filterRecipientReference: filterRecipientReference, filterInternationalDialingCode: filterInternationalDialingCode, filterResultCode: filterResultCode, filterResultText: filterResultText, sortField: sortField, sortOrder: sortOrder).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /recipients
     - GET /recipients

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "total" : 100,
  "offset" : 0,
  "data" : [ {
    "internationalDialingCode" : "0049",
    "resultText" : "The fax was sent successfully",
    "faxNumberNorm" : "0525187929399",
    "senderTime" : "2022-01-01T10:00:00+02:00",
    "name" : "Max Mustermann",
    "resultCode" : 0,
    "faxNumber" : "0525187929399",
    "recipientReference" : "User 1234 ABC",
    "job" : {
      "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
      "target" : ".../jobs/{id}"
    },
    "fareZone" : 1
  }, {
    "internationalDialingCode" : "0049",
    "resultText" : "The fax was sent successfully",
    "faxNumberNorm" : "0525187929399",
    "senderTime" : "2022-01-01T10:00:00+02:00",
    "name" : "Max Mustermann",
    "resultCode" : 0,
    "faxNumber" : "0525187929399",
    "recipientReference" : "User 1234 ABC",
    "job" : {
      "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
      "target" : ".../jobs/{id}"
    },
    "fareZone" : 1
  } ],
  "count" : 50
}}]
     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterJobId: (query) Query parameter to fetch after recipient related to specific fax job (optional)
     - parameter filterSameAccount: (query) Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (optional, default to false)
     - parameter filterFaxNumber: (query) Query parameter to fetch recipients after his fax number (optional)
     - parameter filterFaxNumberNorm: (query) Query parameter to fetch recipients after his normed fax number (optional)
     - parameter filterRecipientReference: (query) Query parameter to fetch recipients after his recipient reference (optional)
     - parameter filterInternationalDialingCode: (query) Query parameter to fetch recipients after his international dialing code (optional)
     - parameter filterResultCode: (query) Query parameter to fetch recipients after his result code (optional)
     - parameter filterResultText: (query) Query parameter to fetch recipients after his result text (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)

     - returns: RequestBuilder<Recipients> 
     */
    open class func getRecipientsWithRequestBuilder(objectLimit: Int? = nil, objectOffset: Int? = nil, filterJobId: String? = nil, filterSameAccount: Bool? = nil, filterFaxNumber: String? = nil, filterFaxNumberNorm: String? = nil, filterRecipientReference: String? = nil, filterInternationalDialingCode: String? = nil, filterResultCode: String? = nil, filterResultText: String? = nil, sortField: SortField_getRecipients? = nil, sortOrder: SortOrder_getRecipients? = nil) -> RequestBuilder<Recipients> {
        let path = "/recipients"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "objectLimit": objectLimit?.encodeToJSON(), 
                        "objectOffset": objectOffset?.encodeToJSON(), 
                        "filterJobId": filterJobId, 
                        "filterSameAccount": filterSameAccount, 
                        "filterFaxNumber": filterFaxNumber, 
                        "filterFaxNumberNorm": filterFaxNumberNorm, 
                        "filterRecipientReference": filterRecipientReference, 
                        "filterInternationalDialingCode": filterInternationalDialingCode, 
                        "filterResultCode": filterResultCode, 
                        "filterResultText": filterResultText, 
                        "sortField": sortField?.rawValue, 
                        "sortOrder": sortOrder?.rawValue
        ])


        let requestBuilder: RequestBuilder<Recipients>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
